<?php

class CMySQL
{
	var $host, $sock, $port, $user, $passwd, $db, $connected, $link, $db_selected;

	function connect()
	{
		if ( $this->connected )
		{
			$this->connected = TRUE;
			return;
		}
                if ($this->sock)
                    $if_sock=":{$this->sock}";
                else
                    $if_sock="";

                if ($this->port)
                    $if_port=":{$this->port}";
                else
                    $if_port="";

		$this->link = mysql_pconnect( "{$this->host}{$if_port}{$if_sock}", $this->user, $this->passwd );
		if ( $this->link )
			$this->connected = TRUE;
		else
			$this->connected = FALSE;
	}

	function select_db()
	{
        $this->db_selected=mysql_select_db( $this->db );
		return $this->db_selected;
	}
}

$MySQL = new CMySQL;

$MySQL->host    = $_GET['host'];
$MySQL->sock    = $_GET['sock'];
$MySQL->port    = $_GET['port'];
$MySQL->user    = $_GET['user'];
$MySQL->passwd  = $_GET['passwd'];
$MySQL->db	    = $_GET['db'];
$MySQL->connected = FALSE;



/*
Database connect and select
Returns: TRUE on success, otherwise dies
*/
function db_connect()
{
	global $MySQL;
	global $site;
	global $ret;
	global $_page;
	
	$MySQL->connect();

	if ( !$MySQL->select_db() )
	{
		mail( $site['bug_report'], 'Error at ' . $site['dir_name'], 'Error: ' . mysql_error() . "\n--\nQuery: \"$query\"\n--\nPage: " . $_SERVER['PHP_SELF'] );
		if ( $site[direct] )
		{
			if ( function_exists( 'TopCode' ) )
			{
				$_page['title'] = 'Database Error';
				$_page['h1'] = 'Sorry...';
				TopCode();
			}
			
			echo 'Sorry, database connect failed.<br>Please, try again later. We appreciate your patience.';
			
			if ( function_exists( 'BottomCode' ) )
				BottomCode();
			exit;
		}
		// indirect calls
		$ret['ErrorCode'] = 2;
		return false;
	}
	return true;
}

/*
Database query
Returns: MySQL result on success, otherwise FALSE or dies
Arguments:	$query - MySQL query text
*/
function db_res( $query )
{
	global $site;
	global $_page;

	$res = mysql_query( $query );
	if ( !$res )
	{
		mail( $site['bug_report'], 'Error at ' . $site['dir_name'], 'Error: ' . mysql_error() . "\n--\nQuery: \"$query\"\n--\nPage: " . $_SERVER['PHP_SELF'] );
		if ( $site['direct'] )
		{
			$_page['title'] = "Error";
			$_page['h1'] = "Sorry...";
			TopCode();
			echo 'An error occured during the attempt to handle your query. Report has been sent to administrators.<br>Please, try again later. We appreciate your patience.';
			BottomCode();
		}
		// indirect calls
		$ret['ErrorCode'] = 9;
		return false;
	}
	return $res;
}

/*
Array from the MySQL result of one-row-select query.
Returns: MySQL array on success, otherwise FALSE or dies
Arguments:	$query - MySQL query text
Description: Note that it adds "LIMIT 1" to the end of the query string, so no "LIMIT" parts of the queries or query termination sign ";" should be ever used in the db_arr argument string.
*/
function db_arr( $query )
{
	global $site;
	global $_page;

	$res = mysql_query( "$query LIMIT 1" );
	if ( !$res )
	{
		mail( $site['bug_report'], 'Error at ' . $site['dir_name'], 'Error: ' . mysql_error() . "\n--\nQuery: \"$query\"\n--\nPage: " . $_SERVER['PHP_SELF'] );
		if ( $site['direct'] )
		{
			$_page[title] = 'Error';
			$_page[h1] = 'Sorry...';
			TopCode();
			echo 'An error occured during the attempt to handle your query. Report has been sent to administrators.<br>Please, try again later. We appreciate your patience.';
			BottomCode();
		}
		// indirect calls
		$ret['ErrorCode'] = 9;
		return false;
	}
	$arr = mysql_fetch_array( $res );
	return $arr;
}

/*
Array from the MySQL result of multiple-rows-select query.
Returns: Array of MySQL arrays, otherwise FALSE
Arguments:	$res - MySQL result
			$count - start index of the returned array
*/
function fill_array( $res, $count = 0 )
{
	if ( !$res )
		return false;
	$i = $count;
	while( $r = mysql_fetch_array( $res ) )
		$arr[$i++] = $r;
	return $arr;
}

/*
Get a global parameter value
Returns: `VALUE` field value from a `GlParams` table record with $param_name index, otherwise false
Arguments:	$param_name - value of `Name` field of `GlParams` table
*/
function getParam( $param_name )
{
	if ( !$line = db_arr( "SELECT VALUE FROM GlParams WHERE Name = '$param_name'" ) )
		return false;
	return $line["VALUE"];
}

/*
Set a global parameter value
Returns: TRUE on success, otherwise FALSE
Arguments:	$param_name - parameter name
			$param_val - parameter value
*/
function setParam( $param_name, $param_val )
{
	if ( !$res = db_res( "UPDATE GlParams SET VALUE = '$param_val' WHERE Name = '$param_name'" ) )
		return false;
	return TRUE;
}

// Connect
db_connect();

?>
